LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY gray2bin IS
    GENERIC (
	    N   : natural := 4
	 );
    PORT (
       gray : IN  std_logic_vector (N-1 DOWNTO 0);
       bin  : OUT std_logic_vector (N-1 DOWNTO 0)
    );
END ENTITY gray2bin;

ARCHITECTURE rtl OF gray2bin IS
  SIGNAL bin_i : std_logic_vector (N-1 DOWNTO 0);
BEGIN
  bin_i(N-1) <= gray(N-1);
  g2b:FOR index IN N-2 DOWNTO 0 GENERATE
    bin_i(index) <= gray(index) XOR bin_i(index+1);
  END GENERATE g2b;
  bin <= bin_i;
END ARCHITECTURE rtl;