ARCHITECTURE rtl_lfsr OF cnt IS
  SIGNAL cnt_d   : std_logic_vector (N-1 DOWNTO 0);
  SIGNAL cnt_q   : std_logic_vector (N-1 DOWNTO 0);
  SIGNAL cnt_xor : std_logic;
BEGIN
  reg_cnt : PROCESS (clk, res)
  BEGIN
      IF res='1' THEN
        cnt_q <= (OTHERS => '1');
      ELSIF clk'EVENT AND clk='1' THEN
        cnt_q <= cnt_d;
      END IF;
  END PROCESS reg_cnt;
  cnt_xor <= cnt_q(1) XOR cnt_q(0);
  cnt_d   <= cnt_xor&cnt_q(N-1 DOWNTO 1);  
  cnt_out <= cnt_q;
END ARCHITECTURE rtl_lfsr;