ARCHITECTURE rtl_ripple OF cnt IS
  SIGNAL cnt_d : std_logic_vector (N-1 DOWNTO 0);
  SIGNAL cnt_q : std_logic_vector (N-1 DOWNTO 0);
  SIGNAL clk_i : std_logic_vector (N-1 DOWNTO 0);
BEGIN

  g_rp:FOR index IN 0 TO N-1 GENERATE
    reg_cnt : PROCESS (clk_i(index), res)
    BEGIN
      IF res='1' THEN
        cnt_q(index) <= '0';
      ELSIF clk_i(index)'EVENT AND clk_i(index)='0' THEN
        cnt_q(index) <= cnt_d(index);
      END IF;
    END PROCESS reg_cnt;
  END GENERATE g_rp;

  clk_i   <= cnt_q(N-2 DOWNTO 0)&NOT(clk);
  cnt_d   <= NOT(cnt_q);
  cnt_out <= cnt_q;
END ARCHITECTURE rtl_ripple;