LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE WORK.cnt_consts.ALL;

ENTITY tb IS
END ENTITY tb;

ARCHITECTURE struct OF tb IS 
  SIGNAL clk : std_logic;
  SIGNAL res : std_logic;
  
  COMPONENT cnt IS
    GENERIC (
	    N   : natural := 4
	 );
    PORT (
       res     : IN  std_logic;
       clk     : IN  std_logic;
       cnt_out : OUT std_logic_vector (N-1 DOWNTO 0)
    );
  END COMPONENT cnt;
  
  FOR i_cnt:cnt USE ENTITY work.cnt(rtl_ripple);
  
BEGIN
  
  gen_clk : PROCESS 
  BEGIN
      clk <= '1';
      WAIT FOR 10 ns;
      clk <= '0';
      WAIT FOR 10 ns;
  END PROCESS gen_clk;
  
  gen_res : PROCESS
  BEGIN
      res <= '1';
      WAIT FOR 50 ns;
      res <= '0';
      WAIT;
  END PROCESS gen_res;
  
  i_cnt : cnt
      GENERIC MAP (
       N       => N_const
      )
      PORT MAP (
       res     => res,
       clk     => clk,
       cnt_out => OPEN
      );
  
END ARCHITECTURE struct;