LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;
USE WORK.cnt_consts.ALL;

ENTITY wrapper IS
  PORT (
     res     : IN  std_logic;
     clk     : IN  std_logic;
     cnt_out : OUT std_logic_vector (N_const-1 DOWNTO 0)
  );
END ENTITY wrapper;

ARCHITECTURE rtl OF wrapper IS
  COMPONENT cnt IS
    GENERIC (
	    N   : natural := 4
	 );
    PORT (
       res     : IN  std_logic;
       clk     : IN  std_logic;
       cnt_out : OUT std_logic_vector (N-1 DOWNTO 0)
    );
  END COMPONENT cnt;
  FOR i_cnt:cnt USE ENTITY work.cnt(rtl_one_hot_bad_impl);
  
BEGIN

 i_cnt:cnt 
   GENERIC MAP (
	  N       => N_const
	)
	PORT MAP (
	  res     => res,
	  clk     => clk,
	  cnt_out => cnt_out
	);

END ARCHITECTURE rtl;